plugins/forum/routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your plugin. These
| routes are loaded by the RouteServiceProvider of your plugin within
| a group which contains the "web" middleware group and your plugin name
| as prefix. Now create something great!
|
*/

Route::middleware('can:forum.forums')->group(function () {
    Route::get('/settings', 'SettingController@show')->name('settings');
    Route::post('/settings', 'SettingController@save')->name('settings.save');

    Route::resource('forums', 'ForumController')->except('show');
    Route::resource('categories', 'CategoryController')->except(['index', 'show']);

    Route::post('/forums/update-order', 'ForumController@updateOrder')->name('forums.update-order');
});

plugins/forum/routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your plugin. These
| routes are loaded by the RouteServiceProvider of your plugin within
| a group which contains the "web" middleware group and your plugin name
| as prefix. Now create something great!
|
*/

Route::get('/', 'ForumController@index')->name('home');
Route::get('/{forum:slug}', 'ForumController@show')->name('show');

Route::prefix('{forum:slug}/discussions')->name('forum.discussions.')->group(function () {
    Route::get('/create', 'ForumDiscussionController@create')->name('create');
    Route::post('/', 'ForumDiscussionController@store')->name('store');
});

Route::resource('discussions', 'DiscussionController')->only(['show', 'edit', 'update', 'destroy']);
Route::resource('discussions.posts', 'DiscussionPostController')->only(['store', 'edit', 'update', 'destroy']);

Route::prefix('discussions{discussion}')->name('discussions.')->group(function () {
    Route::post('/lock', 'DiscussionStatusController@lock')->name('lock');
    Route::post('/unlock', 'DiscussionStatusController@unlock')->name('unlock');
    Route::post('/pin', 'DiscussionStatusController@pin')->name('pin');
    Route::post('/unpin', 'DiscussionStatusController@unpin')->name('unpin');
});

Route::prefix('posts/{post}')->name('posts.')->middleware('auth')->group(function () {
    Route::post('/like', 'PostLikeController@addLike')->name('like');
    Route::delete('/like', 'PostLikeController@removeLike')->name('dislike');
});

plugins/forum/resources/views/discussions/_form.blade.php
@csrf

@include('forum::elements.markdown-editor')

<div class="form-group">
    <label for="titleInput">{{ trans('messages.fields.title') }}</label>
    <input type="text" class="form-control @error('title') is-invalid @enderror" id="titleInput" name="title" value="{{ old('title', $discussion->title ?? '') }}" required>

    @error('title')
    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
    @enderror
</div>

<div class="form-group">
    <label for="content">{{ trans('messages.fields.content') }}</label>
    <textarea class="form-control @error('content') is-invalid @enderror" id="content" name="content" rows="4">{{ old('content', $discussionContent ?? '') }}</textarea>

    @error('content')
    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
    @enderror
</div>

@can('forum.discussions')
    <div class="form-group custom-control custom-switch">
        <input type="checkbox" class="custom-control-input" id="pinSwitch" name="is_pinned" @if($discussion->is_pinned ?? false) checked @endif>
        <label class="custom-control-label" for="pinSwitch">{{ trans('forum::messages.discussions.pin') }}</label>
    </div>

    <div class="form-group custom-control custom-switch">
        <input type="checkbox" class="custom-control-input" id="lockSwitch" name="is_locked" @if($discussion->is_locked ?? false) checked @endif>
        <label class="custom-control-label" for="lockSwitch">{{ trans('forum::messages.discussions.lock') }}</label>
    </div>
@endcan

plugins/forum/resources/views/discussions/create.blade.php
@extends('layouts.app')

@section('title', trans('forum::messages.discussions.title-create'))

@section('content')
    <div class="container content">
        @include('forum::elements.nav')

        <h1 style="font-size: 26px;text-transform: uppercase;margin: 30px 0px;">{{ trans('forum::messages.discussions.title-create') }}</h1>

        <form action="{{ route('forum.forum.discussions.store', $forum->slug) }}" method="POST">
            @include('forum::discussions._form')

            <button type="submit" class="btn btn-primary">
                <i class="fas fa-save"></i> {{ trans('messages.actions.save') }}
            </button>
        </form>
    </div>
@endsection

plugins/forum/resources/views/discussions/edit.blade.php
@extends('layouts.app')

@section('title', trans('forum::messages.discussions.title-edit'))

@section('content')
    <div class="container content">
        @include('forum::elements.nav')

        <h1 style="font-size: 26px;text-transform: uppercase;margin: 30px 0px;">{{ trans('forum::messages.discussions.title-edit') }}</h1>

        <form action="{{ route('forum.discussions.update', $discussion) }}" method="POST">
            @method('PUT')

            @include('forum::discussions._form')

            @can('forum.discussions')
                <div class="form-group">
                    <label for="forumSelect">{{ trans('forum::messages.fields.forum') }}</label>

                    <select class="custom-select" id="forumSelect" name="forum_id">
                        @foreach($forums as $forum)
                            <option value="{{ $forum->id }}" @if($forum->id === old('forum_id', $discussion->forum_id)) selected @endif>{{ $forum->name }}</option>
                        @endforeach
                    </select>

                    @error('forum_id')
                    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                    @enderror
                </div>
            @endcan

            <button type="submit" class="btn btn-primary">
                <i class="fas fa-save"></i>
                {{ trans('messages.actions.save') }}
            </button>
        </form>
    </div>
@endsection

plugins/forum/resources/views/discussions/show.blade.php
@extends('layouts.app')

@section('title', $discussion->title)

@push('meta')
    <meta property="og:article:author:username" content="{{ $discussion->author->name }}">
    <meta property="og:article:published_time" content="{{ $discussion->created_at->toIso8601String() }}">
    <meta property="og:article:modified_time" content="{{ $discussion->updated_at->toIso8601String() }}">
@endpush

@include('forum::elements.markdown-editor', ['editorMinHeight' => 150])

@section('content')
    <div class="container content">
        @include('forum::elements.nav')

        <div class="row mb-2">
            <div class="col-md-9">
                <h1 style="text-transform: uppercase;font-size: 20px;margin: 30px 0px;">{{ $discussion->title }}</h1>
            </div>

            <div class="col-md-3 d-flex align-items-center justify-content-md-end">
                <div>
                    @can('forum.discussions')
                        <form action="{{ route('forum.discussions.'.($discussion->is_pinned ? 'unpin' : 'pin'), $discussion) }}" method="POST" class="d-inline-block">
                            @csrf

                            <button class="btn btn-success btn-sm @if($discussion->is_pinned) active @endif" title="{{ trans('forum::messages.actions.'.($discussion->is_pinned ? 'unpin' : 'pin')) }}" data-toggle="tooltip">
                                <i class="fas fa-thumbtack fa-fw"></i>
                            </button>
                        </form>

                        <form action="{{ route('forum.discussions.'.($discussion->is_locked ? 'unlock' : 'lock'), $discussion) }}" method="POST" class="d-inline-block">
                            @csrf

                            <button class="btn btn-secondary btn-sm @if($discussion->is_locked) active @endif" title="{{ trans('forum::messages.actions.'.($discussion->is_locked ? 'unlock' : 'lock')) }}" data-toggle="tooltip">
                                <i class="fas fa-lock{{ $discussion->is_locked ? '-open' : ''}} fa-fw"></i>
                            </button>
                        </form>
                    @endcan

                    @if(! $discussion->is_locked || optional(auth()->user())->isAdmin())
                        @can('update', $discussion)
                            <a href="{{ route('forum.discussions.edit', $discussion) }}" class="btn btn-info btn-sm" title="{{ trans('messages.actions.edit') }}" data-toggle="tooltip">
                                <i class="fas fa-edit fa-fw"></i>
                            </a>
                        @endcan

                        @can('delete', $discussion)
                            <form action="{{ route('forum.discussions.destroy', $discussion) }}" method="POST" class="d-inline-block" onsubmit="return confirm('{{ trans('forum::messages.discussions.delete') }}')">
                                @csrf
                                @method('DELETE')

                                <button type="submit" class="btn btn-danger btn-sm" title="{{ trans('messages.actions.delete') }}" data-toggle="tooltip">
                                    <i class="fas fa-trash fa-fw"></i>
                                </button>
                            </form>
                        @endcan
                    @endif
                </div>
            </div>
        </div>

        @foreach($discussion->posts as $post)
            <div class="card mb-3">
                <div class="card-body">
                    <div class="row">
                        <div class="col-xl-2 col-md-3 text-center">
                            <div class="row">
                                <div class="col-3 col-md-12">
                                    <img src="{{ game()->getAvatarUrl($post->author, 128) }}" alt="{{ $post->author->name }}" class="img-fluid mb-3 rounded-lg" style="max-width: 80px">
                                </div>

                                <div class="col-9 col-md-12">
                                    <h5 style="margin-bottom: 10px;">{{ $post->author->name }}</h5>

                                    <span class="badge badge-label badge-profil" style="{{ $post->author->role->getBadgeStyle() }};">{{ $post->author->role->name }}</span>
                                </div>
                            </div>

                            <hr>

                            <div class="d-none d-md-block">
                                <ul class="list-unstyled">
                                    <li>
                                        <p>{{ trans('forum::messages.profile.discussions') }}: <span style="color: #885ffb;font-weight: 600;">{{ $post->author->discussions_count }}</span><p>
                                    </li>
                                    <li>
                                        <p>{{ trans('forum::messages.profile.posts') }}: <span style="color: #885ffb;font-weight: 600;">{{ $post->author->posts_count }}</span><p>
                                    </li>
                                    <li>
                                        <p>{{ trans('forum::messages.profile.likes') }}: <span style="color: #885ffb;font-weight: 600;">{{ $post->author->likes_count }}</span><p>
                                    </li>
                                </ul>
                            </div>
                        </div>

                        <div class="col-xl-10 col-md-9">
                            <div class="mb-3">
                                <small>{{ format_date($post->created_at, true) }}</small>
                            </div>

                            <div class="markdown-body mb-3">
                                {{ $post->parseContent() }}
                            </div>
                        </div>
                    </div>
                </div>

                <div class="card-footer text-right">
                    <button type="button" class="btn btn-primary btn-sm @if($post->isLiked()) active @endif" @guest disabled @endguest data-like-url="{{ route('forum.posts.like', $post) }}">
                        <i class="fas fa-thumbs-up"></i>
                        <span class="likes-count">{{ $post->likes->count() }}</span>
                        <span class="d-none spinner-border spinner-border-sm load-spinner" role="status"></span>
                    </button>

                    @if(! $loop->first && (! $discussion->is_locked || optional(auth()->user())->isAdmin()))
                        @can('edit', $post)
                            <a href="{{ route('forum.discussions.posts.edit', [$discussion, $post]) }}" class="btn btn-info btn-sm" title="{{ trans('messages.actions.edit') }}" data-toggle="tooltip">
                                <i class="fas fa-edit fa-fw"></i>
                            </a>
                        @endcan

                        @can('delete', $post)
                            <form action="{{ route('forum.discussions.posts.destroy', [$discussion, $post]) }}" method="POST" class="d-inline-block" onsubmit="return confirm('{{ trans('forum::messages.posts.delete') }}')">
                                @csrf
                                @method('DELETE')

                                <button type="submit" class="btn btn-danger btn-sm" title="{{ trans('messages.actions.delete') }}" data-toggle="tooltip">
                                    <i class="fas fa-trash fa-fw"></i>
                                </button>
                            </form>
                        @endcan
                    @endif
                </div>
            </div>
        @endforeach

        {{ $discussion->posts->links() }}

        @if($discussion->is_locked)
            <div class="alert alert-warning" role="alert">
                <i class="fas fa-lock"></i> {{ trans('forum::messages.discussions.info-locked') }}
            </div>
        @endif

        @if(! $discussion->is_locked || optional(auth()->user())->isAdmin())
            @can('create', \Azuriom\Plugin\Forum\Models\Post::class)
                <div class="card shadow-sm mb-3">
                    <div class="card-header">
                        <span class="h5">{{ trans('forum::messages.discussions.respond') }}</span>
                    </div>
                    <div class="card-body">
                        <form action="{{ route('forum.discussions.posts.store', $discussion) }}" method="POST">
                            @csrf

                            <div class="form-group">
                                <label for="content">{{ trans('messages.fields.content') }}</label>
                                <textarea class="form-control @error('content') is-invalid @enderror" id="content" name="content" rows="4"></textarea>

                                @error('content')
                                <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                                @enderror
                            </div>

                            <button type="submit" class="btn btn-primary">
                                <i class="fas fa-reply"></i> {{ trans('forum::messages.discussions.respond') }}
                            </button>
                        </form>
                    </div>
                </div>
            @endcan
        @endif
    </div>
@endsection